/*   Ա༭
QQ:792758921   
*/
/*====================================================================
  Ҫ
  1.MCU:AT89S52оƬAT89C52
  2.:12MHz
  ע⣺
  򲻴¶Ȳ
  1.LCD1602Һʾ󣬲Ž볬ģ顣
  2.עⳬģԴļԡκԱĵ·ͼ
  3.ûѡƵΪ12MHz˱Ƶʾ,ƬʱĲֵ뷢40KHzƵ岻ԡ
  4.ʹ߾󷢳20KHZ嵱40KHZ塣40KHzƵ壬25us,ռձΪ50% = 12.5us
  5.ÿģ,鿪ϵĵ·Ƿ볬ģ
    ƽŸ, ,ͨ߷ֿϵĵ·
  6.ʹõð壬ȷƬĸλ·;·ǷͬʱƬ31ţEAǵ
    Ӹߵƽ
====================================================================*/
#include <reg52.h>
#include <intrins.h>

#define uchar unsigned char
#define uint  unsigned int

//===============================LCD1602ӿڶ=====================
/*-----------------------------------------------------
       |DB0-----P2.0 | DB4-----P2.4 | RW-------P0.1    |
       |DB1-----P2.1 | DB5-----P2.5 | RS-------P0.2    |
       |DB2-----P2.2 | DB6-----P2.6 | E--------P0.0    |
       |DB3-----P2.3 | DB7-----P2.7 | ע⣬P0.0P0.2Ҫ
    ---------------------------------------------------
=============================================================*/
#define LCM_Data     P0    //ݽӿ
#define Busy         0x80   //ڼLCM״̬еBusyʶ
sbit    LCM_RW     = P2^3;  //дˣLCD1602ĵ
sbit    LCM_RS     = P2^4;  //ĴѡˣLCD1602ĵĽ
sbit    LCM_E      = P2^2;  //ʹź,LCD1602ĵ6
//===============================ģ鶨========================
sbit RemPin  =   P3^2;// ն(޸ģΪⲿж(INT0))
sbit TxPin   =   P3^1;//  
uint length	 = 0;	  // ĳ0.00M
uchar flag = 0;		  // ı־	źŽ=1;
//***************************************************************

void    WriteDataLCM		(uchar WDLCM);//LCDģд
void    WriteCommandLCM	(uchar WCLCM,BuysC); //LCDģдָ
uchar   ReadDataLCM		(void);//LCDģ
uchar   ReadStatusLCM	(void);//LCDģæ
void    DisplayOneChar   (uchar X,uchar Y,uchar ASCII);//ڵX+1еĵY+1λʾһַ
void    DisplayListChar  (uchar X,uchar Y,uchar delayms,uchar code *DData);
void    DisplayCursorPos (uchar X, uchar Y);
void    LCMInit          (void);
void    DisplayIntData   (uchar X, uchar Y,int ZhengShu,uchar Digit,uchar XiaoShu);
void    DisplayCharData  (uchar X, uchar Y,uchar ZiFu);
void delay25us_40KHz(unsigned char us);
void DelayUs(uint us);
void DelayMs(uint Ms);
/*===========================================================================
 
=============================================================================*/
void main(void)
{
   LCMInit();	     //1602ʼ
   EX0 	= 1;        //жж,ʹ INT0 ⲿж
   ET0 = 1;
   TMOD=0x11;       //趨T0Ϊ16λʱ趨T1Ϊ16λʱ
   DisplayOneChar( 1,11,'m');
   DisplayListChar(0,2,0, "Distance: ");	  //ʾַ
   while(1)
   {
	  DisplayIntData(1, 10,length,5,3);//ʾ
	  TH0=0x00;
      TL0=0x00;
	  TR0=1; 		       //ʱ0
	  EA = 1;		       //ж
	  delay25us_40KHz(15); //ź
	  DelayMs(200);	 	 
   }
}	 
/*====================================================================  
 ܣ    1602ʾһ 
˵     ʾһ-9999->32625.  ʾ5λ    
======================================================================*/
void DisplayIntData(uchar X, uchar Y,int ZhengShu,uchar Digit,uchar XiaoShu)
{
      uchar i=0,k=0, BCD[5]={0};
	  if(Digit>5)  Digit=5;
      if(ZhengShu<0)
	  {
         k=1;//ʾ־λ
         ZhengShu=-ZhengShu;
	  }
      BCD[4]  =  ZhengShu / 10000;         //λ
      ZhengShu = ZhengShu % 10000;
      BCD[3]  =  ZhengShu / 1000;          //ǧλ
      ZhengShu = ZhengShu % 1000;
      BCD[2]  =  ZhengShu / 100;           //λ
      ZhengShu = ZhengShu % 100;
      BCD[1]  =  ZhengShu / 10;            //ʮλ
      BCD[0]  =  ZhengShu % 10;            //λ
          
      for(i=0;i<Digit;i++)//ʾֵ
      {    
	       if((i==XiaoShu)&&(0!=XiaoShu))
		   {  
		      DisplayOneChar(X,Y-i,'.');//С 
			  Y= Y-1; 
		    } 
			 
	       DisplayOneChar(X,Y-i,BCD[i]+0x30); //ʾһַ
	  }
      if(k==1)
	  DisplayOneChar(X,Y-1,'-');//
}

//==============================ģӳ================================================
/*====================================================================
  ע⣺12MHz
  趨ʱʱ:x*25us  40KHZ
====================================================================*/
void delay25us_40KHz(unsigned char us)
{
    while(us--)
	{
	  TxPin = 0;
	  _nop_();_nop_();
	  _nop_();_nop_();
	  _nop_();_nop_();
	  _nop_();_nop_();
	  _nop_();_nop_();
	  _nop_();	 
	  TxPin = 1;
	  _nop_();_nop_();
	  _nop_();_nop_();
	}
	TxPin = 1;
}
/*=============================================================================
   жϳ (ע:뷢ĵƽ෴)
===============================================================================*/
void init0int() interrupt 0 
{
        uint timer_us = 0;
		TR0=0; 		             //رնʱ0
		timer_us = 	TH0*256+TL0;
		if(timer_us>190)timer_us=timer_us-180;	//ľ

        if(timer_us<=735)
        {
            timer_us=timer_us-96;//
        } 
        
	    length = ((unsigned long)(329)*timer_us)/2000;//㳤,1000
		flag = 0;
		EA = 0;				    //ֹж
}
/*==================================================================== 
 ܣ1602ʾһַ 
˵ ʾһַ0~256.  ʾ3λ
======================================================================*/
void DisplayCharData(uchar X, uchar Y,uchar ZiFu)
{
      uchar i=0;
      uchar ValueBCD[3];
      ValueBCD[0]  = ZiFu / 100;           //λ
              ZiFu = ZiFu % 100;
      ValueBCD[1]  = ZiFu / 10;            //ʮλ
      ValueBCD[2]  = ZiFu % 10;            //λ
          
      for(i=0;i<3;i++)//ʾֵ
      {         
	       DisplayOneChar(X,Y+i,ValueBCD[i]+0x30); //ʾһַ
	  }
}
/*===========================================================================
   ʱ
=============================================================================*/
void timer0int (void)  interrupt 1 
{
		TR0=0; 		  //رնʱ0
		length = 0;	  //ʱʾʾ0
        flag = 1;	  //
		EA = 0;		  //ֹж  
}
/*======================================================================
 LCMʼ
======================================================================*/
void LCMInit(void) 
{
 LCM_Data = 0;
 WriteCommandLCM(0x38,0); //ʾģʽãæź
 DelayMs(5);
 WriteCommandLCM(0x38,0);
 DelayMs(5);
 WriteCommandLCM(0x38,0);
 DelayMs(5);
 WriteCommandLCM(0x38,1); //ʾģʽ,ʼҪÿμæź
 WriteCommandLCM(0x08,1); //رʾ
 WriteCommandLCM(0x01,1); //ʾ
 WriteCommandLCM(0x06,1); // ʾƶ
 WriteCommandLCM(0x0C,1); // ʾ
 
 DelayMs(100);
}
/*====================================================================
   ʾλ
====================================================================*/
void DisplayCursorPos( unsigned char X, unsigned char Y)
{
 X &= 0x1;
 Y &= 0xF; //Yܴ15Xܴ1
 if (X) Y |= 0x40; //Ҫʾڶʱַ+0x40;
 Y |= 0x80; // ָ
 WriteCommandLCM(Y, 1); //ﲻæźţ͵ַ
}
/*====================================================================  
  ָλʾһַ: X , y
  ע:ַܳ16ַ
======================================================================*/
void DisplayListChar(uchar X,uchar Y,uchar delayms, uchar code *DData)
{
 unsigned char ListLength;

 ListLength = 0;

 X &= 0x1;
 Y &= 0xF; //Xܴ15Yܴ1
 while (DData[ListLength]!='\0') //ִβ˳
  { 
     if (Y <= 0xF) //XӦС0xF
     {
        DisplayOneChar(X, Y, DData[ListLength]); //ʾַ
        ListLength++;
        Y++;
	    DelayMs(delayms);//ʱʾַ
     }
     else
	    break;//ѭ
  }
}
/*====================================================================
  趨ʱʱ:x*1us
====================================================================*/
void DelayUs(uint us)
{
    while(us--);
} 
/*====================================================================
  趨ʱʱ:x*1ms
====================================================================*/
void DelayMs(uint Ms)
{
  uint i,TempCyc;
  for(i=0;i<Ms;i++)
  {
    TempCyc = 250;
    while(TempCyc--);
  }
}
//==============================LCD1602ʾӳ================================================
				  
/*=====================================================================
 дݺ: E = RS=1 RW=0
======================================================================*/
void WriteDataLCM(unsigned char WDLCM)
{
 ReadStatusLCM(); //æ
 LCM_Data = WDLCM;
 LCM_RS = 1;
 LCM_RW = 0;
 LCM_E = 0; //ٶ̫߿Сʱ
 LCM_E = 0; //ʱ
 LCM_E = 1;
}
/*====================================================================
  дָ: E= RS=0 RW=0
======================================================================*/
void WriteCommandLCM(unsigned char WCLCM,BuysC) //BuysCΪ0ʱæ
{
 if (BuysC) ReadStatusLCM(); //Ҫæ
 LCM_Data = WCLCM;
 LCM_RS = 0;
 LCM_RW = 0;
 LCM_E = 0;
 LCM_E = 0;
 LCM_E = 1;
}
/*====================================================================
//
======================================================================*/
unsigned char ReadDataLCM(void)
{
 LCM_RS = 1;
 LCM_RW = 1;
 LCM_E = 0;
 LCM_E = 0;
 LCM_E = 1;
 return(LCM_Data);
}
/*====================================================================
  д֮ǰLCD״̬:E=1 RS=0 RW=1;
  DB7: 0 LCDУ1 LCDæ
  ״̬
======================================================================*/
unsigned char ReadStatusLCM(void)
{
 LCM_Data = 0xFF;
 LCM_RS = 0;
 LCM_RW = 1;
 LCM_E = 0;
 LCM_E = 0;
 LCM_E = 1;
 while (LCM_Data & Busy); //æź  
 return(LCM_Data);
}
/*======================================================================
 :     1602 ָλʾһַ:һλ0~15,ڶ16~31
˵ :      X , y   ע:ַܳ16ַ
======================================================================*/
void DisplayOneChar( unsigned char X, unsigned char Y, unsigned char ASCII)
{
 X &= 0x1;
 Y &= 0xF; //Yܴ15Xܴ1
 if (X) Y |= 0x40; //Ҫʾڶʱַ+0x40;
 Y |= 0x80; // ָ
 WriteCommandLCM(Y, 0); //ﲻæźţ͵ַ
 WriteDataLCM(ASCII);
}