/**********************************************************************
----------------1.:Keil v4					   ----------------
----------------2.ʹõƬͺţSTC89C52RC		   ----------------
----------------3.Ƭʹþ11.0592M			   ----------------
***********************************************************************/

#include "main.h"
#include "HX711.h"
#include "uart.h"
#include "LCD1602.h"

#define uchar unsigned char
#define uint  unsigned int

unsigned long HX711_Buffer = 0;
unsigned long Weight_Maopi = 0;
long Weight_Shiwu = 0;

unsigned char flag = 0;
bit Flag_ERROR = 0;

//У׼
//ΪͬĴ߲Ǻһ£ˣÿһҪʹֵ׼ȷ
//ֲԳƫʱӸֵ
//ԳƫСʱСֵ
//ֵΪС
uint GapValue=716;
uchar flag2;//24C16ͨѶǷı־
//===============================AT24C16Ŷ===================
sbit  sda_24c16=P2^0;//24C16
sbit  scl_24c16=P2^1;//24C16ʱ

void display_weight();//ʾУ׼
void  delay_3us();//3USʱ

void up_Key();//У׼
void down_Key();//СУ׼
void  nack_24c16();//24C16Ӧź   
void  stop_24c16();//ֹͣͨѶź
void  star_24c16();//ź
void  cack_24c16();//Ӧź
void  mack_24c16();//Ӧź
void  w1byte_24c16(uchar byte1);//24C16дһֽڵ
uchar rd1byte_24c16(void);
void  read_24c16();//ݲ
void  write_24c16();//д16ֽڵݲ

//****************************************************
//
//****************************************************
void main()
{
    Uart_Init();
    Send_Word("Welcome to use!\n");
    Send_Word("Made by !\n");
	
	Init_LCD1602();
	LCD1602_write_com(0x80);
	LCD1602_write_word("Welcome to use!");
    Delay_ms(2000);		 //ʱ,ȴȶ
    read_24c16();
	Get_Maopi();				//ëƤ
	
	while(1)
	{
		EA = 0;
		Get_Weight();			//
		EA = 1;

		Scan_Key();
        up_Key();
        down_Key();
		//ʾǰ
	if( Flag_ERROR == 1)
	{
            Send_Word("ERROR\n");
			
			LCD1602_write_com(0x80+0x40);
			LCD1602_write_word("ERROR ");
		}		
		else
		{
            
            display_weight();
            
		}
		
	}
}
//ɨ谴
void up_Key()
{
	if(up_key == 0)
	{
		Delay_ms(5);
		while(up_key == 0)
		{
		   GapValue++;	
	       Get_Weight();
            display_weight();
		}
      	write_24c16();
	}
}
//С
void down_Key()
{
	if(down_key == 0)
	{
		Delay_ms(5);
		while(down_key == 0)
		{
		   GapValue--;	
	       Get_Weight();
           display_weight();
		}
      	write_24c16();
	}
}
void display_weight()
{ 

            Send_ASCII(Weight_Shiwu/1000 + 0X30);
            Send_ASCII(Weight_Shiwu%1000/100 + 0X30);
            Send_ASCII(Weight_Shiwu%100/10 + 0X30);
            Send_ASCII(Weight_Shiwu%10 + 0X30);
            Send_Word(" g\n");
			
			LCD1602_write_com(0x80+0x40);
			LCD1602_write_data(Weight_Shiwu/1000 + 0X30);
            LCD1602_write_data(Weight_Shiwu%1000/100 + 0X30);
            LCD1602_write_data(Weight_Shiwu%100/10 + 0X30);
            LCD1602_write_data(Weight_Shiwu%10 + 0X30);
			LCD1602_write_word(" g");
            //5ʾУ׼ʾֱɾ5
            LCD1602_write_com(0x80+0x40+8);
			LCD1602_write_data(GapValue/1000 + 0X30);
            LCD1602_write_data(GapValue%1000/100 + 0X30);
            LCD1602_write_data(GapValue%100/10 + 0X30);
            LCD1602_write_data(GapValue%10 + 0X30);
		
}
//ɨ谴
void Scan_Key()
{
	if(KEY1 == 0)
	{
		Delay_ms(5);
		if(KEY1 == 0)
		{
			while(KEY1 == 0);
			Get_Maopi();			//ȥƤ
		}	
	}
}

//****************************************************
//
//****************************************************
void Get_Weight()
{
	Weight_Shiwu = HX711_Read();
	Weight_Shiwu = Weight_Shiwu - Weight_Maopi;		//ȡ
	if(Weight_Shiwu > 0)			
	{	
		Weight_Shiwu = (unsigned int)((float)Weight_Shiwu/GapValue); 	//ʵʵ
																		
																		
		if(Weight_Shiwu > 3000)		//ر
		{
			Flag_ERROR = 1;	
		}
		else
		{
			Flag_ERROR = 0;
		}
	}
	else
	{
		Weight_Shiwu = 0;
	//	Flag_ERROR = 1;				//ر
	}
	
}

//****************************************************
//ȡëƤ
//****************************************************
void Get_Maopi()
{
	Weight_Maopi = HX711_Read();	
} 

//****************************************************
//MSʱ(12M²)
//****************************************************
void Delay_ms(unsigned int n)
{
	unsigned int  i,j;
	for(i=0;i<n;i++)
		for(j=0;j<123;j++);
}//***********************************************
//3΢ʱ
void delay_3us()
{ 
  ;
  ; 
}
//ܣͷӦź
void nack_24c16()
{
 sda_24c16=1;    
 delay_3us();
 delay_3us();
 scl_24c16=1;
 delay_3us();
 delay_3us();
 scl_24c16=0;
 sda_24c16=0;
}
//*************************************************
//ܣIICֹͣź
void stop_24c16()
{  
   sda_24c16=0;
   scl_24c16=1;                               
   delay_3us();
   delay_3us();                        
   sda_24c16=1;
   delay_3us();
   delay_3us();                                 
   scl_24c16=0;
}  
//*************************************************
//ܣͨѶź
void star_24c16()
{
  sda_24c16=1;
  scl_24c16=1;
  delay_3us();
  delay_3us();
  sda_24c16=0;
  delay_3us();
  delay_3us();
  scl_24c16=0;
}  
//****************************************************
//ܣжӦӦ
//˵ͨѶʱ־Ϊ1Ϊ0
void cack_24c16()
{  
   scl_24c16=0;
   sda_24c16=1;
   delay_3us();         
   scl_24c16=1;              
   flag2=0;//־   
   if(sda_24c16)flag2=1;
   scl_24c16=0; 
}      
//****************************************************
//ܣӦź
void mack_24c16()  
{ 
  sda_24c16=0;
  scl_24c16=1;
  delay_3us();
  delay_3us();
  scl_24c16=0;
  sda_24c16=1;
}
//*************************************************
//ܣ24C16дһֽڵ
void w1byte_24c16(uchar byte1)
{
  uchar i=8;
  while(i--)    
  {             
    delay_3us();
    delay_3us();
    delay_3us();
    if(byte1 & 0x80)
     {sda_24c16=1;}
    else
     {sda_24c16=0;}
    delay_3us();
    delay_3us();
    delay_3us();
    scl_24c16=1;
    delay_3us();
    delay_3us();
    delay_3us();
    scl_24c16=0;
    byte1<<=1;  
  }
}
//****************************************************
//ܣ24C16жһֽڵ
uchar rd1byte_24c16(void)//;ֽӳ(ͨãݴ30H
{ 
  uchar i;
  uchar ddata=0;
  sda_24c16=1;//IOΪ1׼                       
  for(i=0;i<8;i++)            
  {  
     ddata<<=1;
     delay_3us();
     delay_3us();
     delay_3us();
     scl_24c16=1;  
     if(sda_24c16) ddata++;
     delay_3us();
     delay_3us();
     delay_3us();    
     scl_24c16=0;
  }
  return ddata;
}  
//***************************************************
//ݲ 
void read_24c16()
{ 
  uchar x1,x2;
read1:  
  nack_24c16(); 
  star_24c16();//
  w1byte_24c16(0xa0);//24C16оƬַλ̶Ϊ1010ѡһд
  cack_24c16();
  if(flag2)goto read1; 
  w1byte_24c16(0x10);//д24C16ڲַѡڶҳ 
  cack_24c16(); 
  if(flag2)goto read1; 
  nack_24c16(); 
  stop_24c16();//¿ʼ   
  star_24c16();//
  w1byte_24c16(0xa1);// 24C16оƬַλ̶Ϊ1010ѡһ
  cack_24c16(); 
  if(flag2)goto read1; 
  x1=rd1byte_24c16();
  mack_24c16();
  x2=rd1byte_24c16();
  mack_24c16();
  nack_24c16();
  stop_24c16();
  GapValue=x1*100+x2;
  if(GapValue>=1500)GapValue=00;
  if(GapValue==00)GapValue=70;
}
//****************************************************
//дݲ
void write_24c16()
{
  uchar x1,x2;
write1:
  x1=GapValue/100;
  x2=GapValue%100;
 
  star_24c16();//
  w1byte_24c16(0xa0);//д24C16оƬַλ̶Ϊ1010ѡһд
  cack_24c16();// ȡӦӦź
  if(flag2)goto write1;//ж
  w1byte_24c16(0x10);//д24C16ڲַѡڶҳ
  cack_24c16(); 
  if(flag2)goto write1;
  w1byte_24c16(x1);
  cack_24c16();
  if(flag2)goto write1;
  w1byte_24c16(x2);
  cack_24c16();
  if(flag2)goto write1;
  stop_24c16();//дϣֹͣ                
}  


